<template>
  <div class="container">
    <div class="section">
      <div>
        <title-with-back :back="{ name: 'location' }">Location Detail</title-with-back>
        <div class="buttons is-justify-end">
          <edit-button :to="{ name: 'location-edit', params: { location } }" />
          <refresh-button :loading="fetching" @refresh="fetchData" />
        </div>
      </div>
    </div>

    <div v-if="instance !== null" class="section">
      <div class="field">
        <span class="label">Name</span>
        <div class="control">{{ instance.name }}</div>
      </div>
      <inventory-table :inventories="instance.inventory" />
    </div>
  </div>
</template>

<style scoped lang="scss">
  .section {
    padding-bottom: 0;
  }
</style>

<script lang="ts">
  import Vue from 'vue';
  import Component from 'vue-class-component';
  import { Prop } from 'vue-property-decorator';
  import gql from 'graphql-tag';
  import { Location } from '@/modals/location';
  import { graphqlClient } from '@/client';
  import { InventoryQueryData } from '@/views/common/query';

  const query = gql`
  query LocationDetail($id: String) {
    location(id: $id) {
      id
      name
      inventory {
        id
        status
        lastSeenTime
        location {
          name
        }
        itemType {
          name
        }
      }
     }
   }
  `;

  interface LocationData extends Location {
    inventory: InventoryQueryData[];
  }

  interface QueryData {
    location: LocationData[];
  }

  interface QueryVariable {
    id: string;
  }

  @Component<LocationDetailPage>({
    components: {
      EditButton: () => import('@/components/EditButton.vue'),
      RefreshButton: () => import('@/components/RefreshButton.vue'),
      TitleWithBack: () => import('@/components/TitleWithBack.vue'),
      InventoryTable: () => import('@/components/inventory/InventoryTable.vue'),
    },
  })
  export default class LocationDetailPage extends Vue {
    @Prop({
      type: String,
      required: true,
    }) location!: string;

    instance: Location | null = null;
    fetching: boolean = false;

    mounted() {
      return this.fetchData();
    }

    fetchData() {
      this.fetching = true;
      return graphqlClient.query<QueryData, QueryVariable>({
        query,
        variables: { id: this.location },
      })
        .then(({ data: { location } }) => {
          if (location.length !== 1) {
            this.$router.replace({ name: 'location' });
            return;
          }
          this.instance = location[0];
          this.fetching = false;
        });
    }
  }
</script>
